#!/usr/bin/env python3
import pika

connection = pika.BlockingConnection(pika.ConnectionParameters("localhost"))
channel = connection.channel()

channel.queue_declare(queue="hello")


def callback(ch, method, properties, body):
    # instead of b'Hello World!'
    text = body.decode("utf-8")
    print(" [x] Received", text)


channel.basic_consume(queue="hello", auto_ack=True, on_message_callback=callback)
print(" [*] Waiting for messages. To exit press CTRL+C")
channel.start_consuming()

connection.close()

